<template>
  <client-only>
    <div class="relative bg-white">
      <section>
        <div class="grid grid-cols-12 gap-0">
          <div class="col-span-12 px-10 py-16 lg:col-span-9 bg-secondary-100">
            <!-- #billing -->
            <div class="md:grid md:grid-cols-4 md:gap-5">
              <div class="md:col-span-1">
                <div class="px-4 sm:px-0">
                  <h3 class="text-lg font-medium leading-6 text-gray-900">
                    Billing address
                  </h3>
                  <!-- <p class="mt-1 text-sm text-gray-600">
                    Lorem ipsum, dolor sit amet consectetur adipisicing elit.
                  </p> -->
                </div>
              </div>
              <div class="mt-5 md:mt-0 md:col-span-3">
                <div class="shadow sm:rounded-md sm:overflow-hidden">
                  <div class="px-4 py-5 space-y-6 bg-white sm:p-6">
                    <div class="grid grid-cols-4 gap-5">
                      <div class="col-span-4 sm:col-span-2">
                        <label
                          for="billing-firstName"
                          class="block text-sm font-medium text-black"
                        >
                          Firstname
                        </label>
                        <div class="mt-1">
                          <input
                            id="billing-firstName"
                            v-model="billing.firstName"
                            name="billing-firstName"
                            type="text"
                            required
                            class="w-full form-input"
                            @change="paymentAvailable = false"
                          />
                        </div>
                      </div>

                      <div class="col-span-4 sm:col-span-2">
                        <label
                          for="billing-lastName"
                          class="block text-sm font-medium text-black"
                        >
                          Lastname
                        </label>
                        <div class="mt-1">
                          <input
                            id="billing-lastName"
                            v-model="billing.lastName"
                            name="billing-lastName"
                            type="text"
                            required
                            class="w-full form-input"
                            @change="paymentAvailable = false"
                          />
                        </div>
                      </div>

                      <div class="col-span-4 sm:col-span-2">
                        <label
                          for="billing-email"
                          class="block text-sm font-medium text-black"
                        >
                          Email
                        </label>
                        <div class="mt-1">
                          <input
                            id="billing-email"
                            v-model="billing.email"
                            name="billing-email"
                            type="email"
                            required
                            class="w-full form-input"
                            @change="paymentAvailable = false"
                          />
                        </div>
                      </div>

                      <div class="col-span-4 sm:col-span-2">
                        <label
                          for="billing-phone"
                          class="block text-sm font-medium text-black"
                        >
                          Phone
                        </label>
                        <div class="mt-1">
                          <input
                            id="billing-phone"
                            v-model="billing.phone"
                            name="billing-phone"
                            type="tel"
                            required
                            class="w-full form-input"
                            @change="paymentAvailable = false"
                          />
                        </div>
                      </div>

                      <div class="col-span-4 sm:col-span-4">
                        <label
                          for="billing-address1"
                          class="block text-sm font-medium text-black"
                        >
                          Address
                        </label>
                        <div class="mt-1">
                          <input
                            id="billing-address1"
                            v-model="billing.address1"
                            name="billing-address1"
                            type="text"
                            required
                            class="w-full form-input"
                            @change="paymentAvailable = false"
                          />
                        </div>
                      </div>

                      <div class="col-span-4 sm:col-span-3">
                        <label
                          for="billing-address2"
                          class="block text-sm font-medium text-black"
                        >
                          Address 2
                          <span class="ml-2 text-xs text-secondary-200">
                            (optional)
                          </span>
                        </label>
                        <div class="mt-1">
                          <input
                            id="billing-address2"
                            v-model="billing.address2"
                            data-validation="optional"
                            name="billing-address2"
                            type="text"
                            required
                            class="w-full form-input"
                            @change="paymentAvailable = false"
                          />
                        </div>
                      </div>

                      <div class="col-span-4 md:col-span-1">
                        <label
                          for="billing-postcode"
                          class="block text-sm font-medium text-black"
                        >
                          Postal code
                        </label>
                        <div class="mt-1">
                          <input
                            id="billing-postcode"
                            v-model="billing.postcode"
                            name="billing-postcode"
                            type="text"
                            required
                            class="w-full form-input"
                            @change="paymentAvailable = false"
                          />
                        </div>
                      </div>

                      <div class="col-span-4 sm:col-span-1">
                        <label
                          for="billing-city"
                          class="block text-sm font-medium text-black"
                        >
                          City
                        </label>
                        <div class="mt-1">
                          <input
                            id="billing-city"
                            v-model="billing.city"
                            name="billing-city"
                            type="text"
                            required
                            class="w-full form-input"
                            @change="paymentAvailable = false"
                          />
                        </div>
                      </div>

                      <div class="col-span-4 sm:col-span-1">
                        <label
                          for="billing-state"
                          class="block text-sm font-medium text-black"
                        >
                          State
                        </label>
                        <div class="mt-1">
                          <input
                            id="billing-state"
                            v-model="billing.state"
                            name="billing-state"
                            type="text"
                            required
                            class="w-full form-input"
                            @change="paymentAvailable = false"
                          />
                        </div>
                      </div>

                      <div class="col-span-4 sm:col-span-2">
                        <label
                          for="billing-country"
                          class="block text-sm font-medium text-black"
                        >
                          Country
                        </label>
                        <div class="mt-1">
                          <select
                            id="billing-country"
                            v-model="billing.country"
                            name="billing-country"
                            type="text"
                            required
                            class="w-full form-select"
                            @change="paymentAvailable = false"
                          >
                            <option
                              v-for="(country, index) in countries"
                              :key="index"
                              :value="country.code"
                            >
                              {{ country.name }}
                            </option>
                          </select>
                        </div>
                      </div>

                      <div class="col-span-4 sm:col-span-4">
                        <div class="flex items-center">
                          <input
                            id="sameForShipping"
                            v-model="sameForShipping"
                            name="sameForShipping"
                            type="checkbox"
                            class="text-primary-400 form-checkbox"
                            @change="paymentAvailable = false"
                          />
                          <label
                            for="sameForShipping"
                            class="block ml-2 text-sm font-medium text-black"
                          >
                            Use same infomation for Shipping
                          </label>
                        </div>
                      </div>
                    </div>
                  </div>
                  <div class="px-4 py-3 text-right bg-gray-50 sm:px-6">
                    <button
                      type="submit"
                      class="inline-flex justify-center px-4 py-2 text-sm font-medium text-white border border-transparent rounded-md shadow-sm bg-primary-300 hover:bg-primary-400 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-primary-300"
                      @click.prevent="checkForm"
                    >
                      Save
                    </button>
                  </div>
                </div>
              </div>
            </div>

            <!-- #shipping -->
            <div
              v-if="!sameForShipping"
              class="mt-5 md:grid md:grid-cols-4 md:gap-5"
            >
              <div class="md:col-span-1">
                <div class="px-4 sm:px-0">
                  <h3 class="text-lg font-medium leading-6 text-gray-900">
                    Shipping address
                  </h3>
                  <!-- <p class="mt-1 text-sm text-gray-600">
                    Lorem ipsum, dolor sit amet consectetur adipisicing elit.
                  </p> -->
                </div>
              </div>
              <div class="mt-5 md:mt-0 md:col-span-3">
                <div class="shadow sm:rounded-md sm:overflow-hidden">
                  <div class="px-4 py-5 space-y-6 bg-white sm:p-6">
                    <div class="grid grid-cols-4 gap-5">
                      <div class="col-span-4 sm:col-span-2">
                        <label
                          for="shipping-firstName"
                          class="block text-sm font-medium text-black"
                        >
                          Firstname
                        </label>
                        <div class="mt-1">
                          <input
                            id="shipping-firstName"
                            v-model="shipping.firstName"
                            name="shipping-firstName"
                            type="text"
                            required
                            class="w-full form-input"
                            @change="paymentAvailable = false"
                          />
                        </div>
                      </div>

                      <div class="col-span-4 sm:col-span-2">
                        <label
                          for="shipping-lastName"
                          class="block text-sm font-medium text-black"
                        >
                          Lastname
                        </label>
                        <div class="mt-1">
                          <input
                            id="shipping-lastName"
                            v-model="shipping.lastName"
                            name="shipping-lastName"
                            type="text"
                            required
                            class="w-full form-input"
                            @change="paymentAvailable = false"
                          />
                        </div>
                      </div>

                      <!-- <div class="col-span-1 sm:col-span-2">
                        <label
                          for="shipping-email"
                          class="block text-sm font-medium text-black"
                        >
                          Email
                        </label>
                        <div class="mt-1">
                          <input
                            id="shipping-email"
                            v-model="shipping.email"
                            name="shipping-email"
                            type="email"
                            required
                            class="w-full form-input"
                            @change="paymentAvailable = false"
                          />
                        </div>
                      </div> -->

                      <!-- <div class="col-span-1 sm:col-span-2">
                        <label
                          for="shipping-phone"
                          class="block text-sm font-medium text-black"
                        >
                          Phone
                        </label>
                        <div class="mt-1">
                          <input
                            id="shipping-phone"
                            v-model="shipping.phone"
                            name="shipping-phone"
                            type="tel"
                            required
                            class="w-full form-input"
                            @change="paymentAvailable = false"
                          />
                        </div>
                      </div> -->

                      <div class="col-span-4 sm:col-span-4">
                        <label
                          for="shipping-address1"
                          class="block text-sm font-medium text-black"
                        >
                          Address
                        </label>
                        <div class="mt-1">
                          <input
                            id="shipping-address1"
                            v-model="shipping.address1"
                            name="shipping-address1"
                            type="text"
                            required
                            class="w-full form-input"
                            @change="paymentAvailable = false"
                          />
                        </div>
                      </div>

                      <div class="col-span-4 sm:col-span-3">
                        <label
                          for="shipping-address2"
                          class="block text-sm font-medium text-black"
                        >
                          Address 2
                          <span class="ml-2 text-xs text-secondary-200">
                            (optional)
                          </span>
                        </label>
                        <div class="mt-1">
                          <input
                            id="shipping-address2"
                            v-model="shipping.address2"
                            data-validation="optional"
                            name="shipping-address2"
                            type="text"
                            required
                            class="w-full form-input"
                            @change="paymentAvailable = false"
                          />
                        </div>
                      </div>

                      <div class="col-span-4 sm:col-span-1">
                        <label
                          for="shipping-postcode"
                          class="block text-sm font-medium text-black"
                        >
                          Postal code
                        </label>
                        <div class="mt-1">
                          <input
                            id="shipping-postcode"
                            v-model="shipping.postcode"
                            name="shipping-postcode"
                            type="text"
                            required
                            class="w-full form-input"
                            @change="paymentAvailable = false"
                          />
                        </div>
                      </div>

                      <div class="col-span-4 sm:col-span-1">
                        <label
                          for="shipping-city"
                          class="block text-sm font-medium text-black"
                        >
                          City
                        </label>
                        <div class="mt-1">
                          <input
                            id="shipping-city"
                            v-model="shipping.city"
                            name="shipping-city"
                            type="text"
                            required
                            class="w-full form-input"
                            @change="paymentAvailable = false"
                          />
                        </div>
                      </div>

                      <div class="col-span-4 sm:col-span-1">
                        <label
                          for="shipping-state"
                          class="block text-sm font-medium text-black"
                        >
                          State
                        </label>
                        <div class="mt-1">
                          <input
                            id="shipping-state"
                            v-model="shipping.state"
                            name="shipping-state"
                            type="text"
                            required
                            class="w-full form-input"
                            @change="paymentAvailable = false"
                          />
                        </div>
                      </div>

                      <div class="col-span-4 sm:col-span-2">
                        <label
                          for="shipping-country"
                          class="block text-sm font-medium text-black"
                        >
                          Country
                        </label>
                        <div class="mt-1">
                          <select
                            id="shipping-country"
                            v-model="shipping.country"
                            name="shipping-country"
                            type="text"
                            required
                            class="w-full form-select"
                            @change="paymentAvailable = false"
                          >
                            <option
                              v-for="(country, index) in countries"
                              :key="index"
                              :value="country.code"
                            >
                              {{ country.name }}
                            </option>
                          </select>
                        </div>
                      </div>
                    </div>
                  </div>
                  <div class="px-4 py-3 text-right bg-gray-50 sm:px-6">
                    <button
                      type="submit"
                      class="inline-flex justify-center px-4 py-2 text-sm font-medium text-white border border-transparent rounded-md shadow-sm bg-primary-300 hover:bg-primary-400 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-primary-300"
                      @click.prevent="checkForm"
                    >
                      Save
                    </button>
                  </div>
                </div>
              </div>
            </div>
            <!-- <pre>
              {{ paypalItems }}
              {{ roundToTwo(amount) }}
            </pre> -->
          </div>

          <div
            class="flex flex-col items-center justify-between col-span-12 px-10 py-16 lg:col-span-3"
          >
            <div class="w-full">
              <div
                class="flex items-center justify-between w-full pb-5 border-b border-secondary-200"
              >
                <h3 class="text-xl font-medium">Order Summary</h3>
              </div>

              <div class="pb-10 mt-10 border-b border-secondary-200">
                <div class="mt-5">
                  <client-only>
                    <label class="block">
                      <span class="font-semibold text-black">Promo Code</span>

                      <input
                        id="code-input"
                        ref="code-input"
                        v-model="formValues.coupon"
                        type="text"
                        class="block w-full mt-1 form-input"
                        placeholder="Enter your code"
                      />
                    </label>
                  </client-only>
                </div>
              </div>
            </div>

            <div class="w-full">
              <div class="mt-10">
                <div class="flex items-center justify-between mb-3">
                  <div>
                    <span class="font-semibold text-secondary-400">
                      Subtotal
                    </span>
                  </div>
                  <div>
                    <span class="text-secondary-400">
                      {{
                        this.$store.state.cart.cart
                          ? this.$store.state.cart.cart.subtotal
                          : 0
                      }}
                    </span>
                  </div>
                </div>

                <div class="flex items-center justify-between mb-3">
                  <div>
                    <span class="font-semibold text-secondary-400"
                      >Shipping</span
                    >
                  </div>
                  <div>
                    <span class="text-secondary-400">
                      {{
                        this.$store.state.cart.cart
                          ? this.$store.state.cart.cart.shippingTotal
                          : 0
                      }}
                    </span>
                  </div>
                </div>

                <div class="flex items-center justify-between mb-3">
                  <div>
                    <span class="font-semibold text-secondary-400">Tax</span>
                  </div>
                  <div>
                    <span class="text-secondary-400">
                      {{
                        this.$store.state.cart.cart
                          ? this.$store.state.cart.cart.totalTax
                          : 0
                      }}
                    </span>
                  </div>
                </div>
                <client-only v-if="this.$store.state.cart.cart">
                  <div
                    v-if="this.$store.state.cart.cart.appliedCoupons"
                    class="flex items-center justify-between mb-3"
                  >
                    <div>
                      <span class="font-semibold text-secondary-400"
                        >Discount</span
                      >
                    </div>
                    <div>
                      <span class="text-primary-200">
                        - {{ this.$store.state.cart.cart.discountTotal }}
                      </span>
                    </div>
                  </div>
                </client-only>

                <div class="flex items-center justify-between">
                  <div>
                    <span class="text-xl font-semibold text-black">Total</span>
                  </div>
                  <div>
                    <span>
                      {{
                        this.$store.state.cart.cart
                          ? this.$store.state.cart.cart.total
                          : 0
                      }}
                    </span>
                  </div>
                </div>
              </div>

              <!-- #buttons -->
              <div class="mt-5">
                <button
                  class="btn secondary small"
                  :disabled="!needUpdate"
                  @click.prevent="updateCart"
                >
                  Update
                </button>

                <div
                  id="payment-section"
                  class="mt-5"
                  :class="[{ 'disable-pay': !paymentAvailable }]"
                >
                  <client-only v-if="this.$store.state.cart.cart">
                    <!-- env: production || sandbox -->
                    <paypal-checkout
                      env="production"
                      :amount="roundToTwo(amount).toString()"
                      currency="USD"
                      locale="en_US"
                      :button-style="paypal.btn"
                      :client="paypal.credentials"
                      :experience="paypal.experienceOptions"
                      :items="paypalItems"
                      @payment-authorized="authorized"
                      @payment-completed="completed"
                      @payment-cancelled="cancelled"
                    >
                    </paypal-checkout>
                  </client-only>
                </div>
              </div>
            </div>
          </div>
        </div>
      </section>
    </div>
  </client-only>
</template>

<script>
import COUNTRIES from '~/db/countries.js'

import createOrder from '~/apollo/mutations/createOrder.gql'

import {
  PAYPAL_SANDBOX_CLIENT_ID,
  PAYPAL_PRODUCTION_CLIENT_ID,
} from '~/constants.js'

export default {
  data() {
    return {
      amount: 0,
      paypal: {
        credentials: {
          sandbox: PAYPAL_SANDBOX_CLIENT_ID,
          production: PAYPAL_PRODUCTION_CLIENT_ID,
        },
        btn: {
          label: 'checkout',
          size: 'responsive',
          shape: 'rect',
          color: 'gold',
        },
        experienceOptions: {
          input_fields: {
            no_shipping: 1,
            address_override: 1,
          },
          presentation: {
            logo_image: 'https://admin.molygo.com/wp-content/uploads/logo.png',
          },
        },
      },
      countries: COUNTRIES,
      formValues: {
        coupon: null,
        rate: null,
      },
      errors: [],
      billing: {
        firstName: this.$store.state.auth.customer?.billing.firstName || null,
        lastName: this.$store.state.auth.customer?.billing.lastName || null,
        email: this.$store.state.auth.customer?.billing.email || null,
        phone: this.$store.state.auth.customer?.billing.phone || null,
        address1: this.$store.state.auth.customer?.billing.address1 || null,
        address2: this.$store.state.auth.customer?.billing.address2 || null,
        postcode: this.$store.state.auth.customer?.billing.postcode || null,
        city: this.$store.state.auth.customer?.billing.city || null,
        state: this.$store.state.auth.customer?.billing.state || null,
        country: this.$store.state.auth.customer?.billing.country || null,
      },
      shipping: {
        firstName: this.$store.state.auth.customer?.shipping.firstName || null,
        lastName: this.$store.state.auth.customer?.shipping.lastName || null,
        // email: this.$store.state.auth.customer?.shipping.email || null,
        // phone: this.$store.state.auth.customer?.shipping.phone || null,
        address1: this.$store.state.auth.customer?.shipping.address1 || null,
        address2: this.$store.state.auth.customer?.shipping.address2 || null,
        postcode: this.$store.state.auth.customer?.shipping.postcode || null,
        city: this.$store.state.auth.customer?.shipping.city || null,
        state: this.$store.state.auth.customer?.shipping.state || null,
        country: this.$store.state.auth.customer?.shipping.country || null,
      },
      sameForShipping: true,
      paymentAvailable: false,
      lineItems: [],
      rate: 10.69,
    }
  },
  computed: {
    needUpdate() {
      return !!(this.formValues.coupon || this.formValues.rate)
    },

    paypalItems() {
      const items = []
      if (this.$store.state.cart.cart) {
        let shippingAmountByItem =
          // eslint-disable-next-line prettier/prettier
          (this.rate / this.$store.state.cart.cart.contents.itemCount)

        shippingAmountByItem = parseFloat(shippingAmountByItem.toFixed(2))

        this.resetAmmount()
        this.$store.state.cart.cart.contents.nodes.forEach((item) => {
          const price = parseFloat(item.total.split('$')[1].replace(',', ''))
          // eslint-disable-next-line prettier/prettier
          const finalPrice = (price / item.quantity) + shippingAmountByItem

          items.push({
            name: item.product.node.name,
            description: item.variation
              ? `Size: ${item.variation.attributes[0].value}`
              : '',
            quantity: item.quantity.toString(),
            // eslint-disable-next-line prettier/prettier
            price: this.roundToTwo(finalPrice).toString(),
            currency: 'USD',
          })

          // eslint-disable-next-line prettier/prettier
          this.amount += finalPrice.toFixed(2) * item.quantity
        })
      }
      return items
    },
  },
  created() {
    if (!this.$apolloHelpers.getToken()) {
      this.$router.push({
        name: 'signin',
        params: { redirectTo: this.$route.path },
      })
    }

    if (!this.$store.state.cart.cart) {
      this.$router.push('/shop')
    } else {
      this.paymentAvailable = true
    }
  },
  methods: {
    async updateCart() {
      await this.$store.dispatch('cart/fillCart', {
        coupons: [this.formValues.coupon.toLowerCase()],
        items: this.$store.state.cart.items,
        redirectTo: '/checkout',
      })
    },

    roundToTwo(num) {
      return +(Math.round(num + 'e+2') + 'e-2')
    },

    resetAmmount() {
      this.amount = 0
    },

    authorized(data) {
      this.$store.dispatch('cart/setCheckout', { event: 'authorized', data })
    },

    completed(data) {
      this.$store.dispatch('cart/setCheckout', { event: 'completed', data })
      this.createOrder()
    },

    cancelled(data) {
      this.$store.dispatch('cart/setCheckout', { event: 'cancelled', data })
    },

    async createOrder() {
      this.$store.dispatch('system/setNotification', {
        type: 'check',
        title: 'Your purchase was completed successfully!',
        message: 'Thank you for your purchase!.',
        duration: 5000,
      })
      await this.$store.state.cart.cart.contents.nodes.forEach((product) => {
        this.lineItems.push({
          productId: product.product.node.databaseId,
          quantity: product.quantity,
          sku: '',
          name: product.product.node.name,
          variationId: product.variation
            ? product.variation.node.databaseId
            : null,
        })
      })

      this.$apollo
        .mutate({
          mutation: createOrder,
          variables: {
            input: {
              status: 'PENDING',
              transactionId: this.$store.state.cart.checkout.authorized.orderID,
              billing: this.billing,
              shipping: this.sameForShipping ? this.billing : this.shipping,
              currency: 'USD',
              coupons: this.$store.state.cart.cart.appliedCoupons
                ? [this.$store.state.cart.cart.appliedCoupons[0].code]
                : '',
              paymentMethod: 'paypal',
              paymentMethodTitle: 'PayPal',
              isPaid: true,
              customerId: this.$store.state.auth.customer.databaseId,
              clientMutationId: this.$store.state.auth.clientMutationId,
              lineItems: this.lineItems,
              shippingLines: [
                {
                  total: this.$store.state.cart.cart.shippingTotal,
                  methodId: '',
                  methodTitle: '',
                },
              ],
            },
          },
          update: (data) => {},
        })
        .then((data) => {
          this.$store.dispatch('cart/removeAllItemsFromSystem')
          this.$store.dispatch('system/setNotification', {
            type: 'check',
            title: 'Your order has been created successfully!',
            message: 'You will be redirected.',
            duration: 5000,
          })

          this.$router.push(`/orders/${data.data.createOrder.orderId}`)
        })
        .catch((error) => {
          console.error(error)
        })
    },

    async checkForm() {
      this.paymentAvailable = false
      const billingVerify = await this.verifyInputs(this.billing, 'billing', 0)
      const shippingVerify = !this.sameForShipping
        ? await this.verifyInputs(this.shipping, 'shipping', 1)
        : true

      if (billingVerify && shippingVerify) {
        this.$store.dispatch('auth/updateCustomer', {
          billing: this.billing,
          shipping: this.sameForShipping ? this.billing : this.shipping,
          sameForShipping: this.sameForShipping,
          redirectTo: '/checkout',
        })

        this.paymentAvailable = true
      }
    },

    verifyInputs(obj, label, index) {
      let count = Object.keys(obj).length

      for (const key in obj) {
        const element = document.getElementById(`${label}-${key}`)

        if (obj[key] !== null && obj[key] !== '') {
          element.classList.remove('error')
          element.classList.add('valid')
          count--
        } else if (element.getAttribute('data-validation') === 'optional') {
          count--
          continue
        } else {
          element.classList.remove('valid')
          element.classList.add('error')
          break
        }
      }

      return count === 0
    },
  },
}
</script>

<style>
.valid {
  @apply border-success;
}

.error {
  @apply border-primary-300;
}

.disable-pay {
  @apply pointer-events-none;
  @apply cursor-not-allowed;
  @apply opacity-50;
}
</style>
